package dicewars.util;

/*
 *  All directions from a given hex (in a hex grid with (0,0) in top left corner)
 *
 *  Note: The Hex is flipped, directions like
 *
 *      SE  SW
 *    E        W
 *      NE  NW
 *
 *
 *   Nothing to do here!
 *
 */

public enum Directions {
    // NOTE: The ordering matters, used by GUI
    // when rendering borders i.e. using d.ordinal()
    NW(0, 1),   // North west, dX = 0, dY = 1
    NE(-1, 1),  // North east
    E(-1, 0),   // East
    SE(0, -1),  // South east
    SW(1, -1),  // South west
    W(1, 0);    // West

    // Accessible as dir.dX and dir.dY
    public final int dX, dY;

    Directions(int dX, int dY) {
        this.dX = dX;
        this.dY = dY;
    }

}
